import { Distribution, Server, Module, Required as LatesRequired, JavaVersionProps } from 'lates-distribution-types';
import { MavenComponents } from '../util/MavenUtil';
export declare class LatesDistribution {
    readonly rawDistribution: Distribution;
    private mainServerIndex;
    readonly servers: LatesServer[];
    constructor(rawDistribution: Distribution, commonDir: string, instanceDir: string);
    private resolveMainServerIndex;
    getMainServer(): LatesServer | null;
    getServerById(id: string): LatesServer | null;
}
export declare class LatesServer {
    readonly rawServer: Server;
    readonly modules: LatesModule[];
    readonly hostname: string;
    readonly port: number;
    readonly effectiveJavaOptions: Required<JavaVersionProps>;
    constructor(rawServer: Server, commonDir: string, instanceDir: string);
    private parseAddress;
    private parseEffectiveJavaOptions;
    private defaultUndefinedJavaOptions;
    private defaultJavaVersion;
    private defaultJavaPlatform;
}
export declare class LatesModule {
    readonly rawModule: Module;
    private readonly serverId;
    readonly subModules: LatesModule[];
    private readonly mavenComponents;
    private readonly required;
    private readonly localPath;
    constructor(rawModule: Module, serverId: string, commonDir: string, instanceDir: string);
    private resolveMavenComponents;
    private resolveRequired;
    private resolveLocalPath;
    hasMavenComponents(): boolean;
    getMavenComponents(): Readonly<MavenComponents>;
    getRequired(): Readonly<Required<LatesRequired>>;
    getPath(): string;
    getMavenIdentifier(): string;
    getExtensionlessMavenIdentifier(): string;
    getVersionlessMavenIdentifier(): string;
    hasSubModules(): boolean;
}
