import { IndexProcessor } from '../IndexProcessor';
import { Asset } from '../Asset';
import { LatesDistribution, LatesModule } from '../../common/distribution/DistributionFactory';
import { VersionJsonBase } from '../mojang/MojangTypes';
export declare class DistributionIndexProcessor extends IndexProcessor {
    protected distribution: LatesDistribution;
    protected serverId: string;
    private static readonly logger;
    constructor(commonDir: string, distribution: LatesDistribution, serverId: string);
    init(): Promise<void>;
    totalStages(): number;
    validate(onStageComplete: () => Promise<void>): Promise<{
        [category: string]: Asset[];
    }>;
    postDownload(): Promise<void>;
    private validateModules;
    loadModLoaderVersionJson(): Promise<VersionJsonBase>;
    loadVersionManifest<T>(modLoaderModule: LatesModule): Promise<T>;
    static isForgeGradle3(mcVersion: string, forgeVersion: string): boolean;
}
